/*
 *      straightDefs.h
 */

#ifndef __STRAIGHTDEFS_H
#define __STRAIGHTDEFS_H

#include <straight/straightCB.h>

#ifdef __cplusplus
extern "C" {
#endif
    
#define STRAIGHT_VERSION_STRING      "1.1.4"
#define STRAIGHT_VERSION             1
#define STRAIGHT_REVISION            1
#define STRAIGHT_UPDATE_LEVEL        4
#define STRAIGHT_VERSION_ID          (STRAIGHT_VERSION * 1000 + STRAIGHT_REVISION)

#define STRAIGHT_V40_ENGINE_VERSION_STRING	"2.0.2 (V40_005b)"
#define STRAIGHT_V40_ENGINE_VERSION_STRING_SHORT	"V40_005b"
#define STRAIGHT_V40_ENGINE_VERSION             2
#define STRAIGHT_V40_ENGINE_REVISION            0
#define STRAIGHT_V40_ENGINE_UPDATE_LEVEL        2
#define STRAIGHT_V40_ENGINE_VERSION_ID          (STRAIGHT_V40_ENGINE_VERSION * 1000 + STRAIGHT_V40_ENGINE_REVISION)

#define STRAIGHT_ENGINE_VERSION_STRING      	STRAIGHT_V40_ENGINE_VERSION_STRING
#define STRAIGHT_ENGINE_VERSION             	STRAIGHT_V40_ENGINE_VERSION
#define STRAIGHT_ENGINE_REVISION            	STRAIGHT_V40_ENGINE_REVISION
#define STRAIGHT_ENGINE_UPDATE_LEVEL        	STRAIGHT_V40_ENGINE_UPDATE_LEVEL
#define STRAIGHT_ENGINE_VERSION_ID    		STRAIGHT_V40_ENGINE_VERSION_ID      
    
#define STRAIGHT_V30_ENGINE_VERSION_STRING	"1.8.0 (V30_kr18)"
#define STRAIGHT_V30_ENGINE_VERSION_STRING_SHORT	"V30_kr18"
#define STRAIGHT_V30_ENGINE_VERSION_ID		1008
    
#define STRAIGHT_TANDEM_ENGINE_VERSION_STRING	"3.3.0 (Tandem-STRAIGHT MP004Test)"
#define STRAIGHT_TANDEM_ENGINE_VERSION_STRING_SHORT	"MP004Test"
#define STRAIGHT_TANDEM_ENGINE_VERSION		3
#define STRAIGHT_TANDEM_ENGINE_REVISION		3
#define STRAIGHT_TANDEM_ENGINE_UPDATE_LEVEL	0
#define STRAIGHT_TANDEM_ENGINE_VERSION_ID	(STRAIGHT_TANDEM_ENGINE_VERSION * 1000 + STRAIGHT_TANDEM_ENGINE_REVISION)

#define STRAIGHT_TANDEM_V008_ENGINE_VERSION_STRING		"3.0.1 (Tandem-STRAIGHT V008c)"
#define STRAIGHT_TANDEM_V008_ENGINE_VERSION_STRING_SHORT	"V008c"
#define STRAIGHT_TANDEM_V008_ENGINE_VERSION_ID			3000
#define STRAIGHT_TANDEM_V009_ENGINE_VERSION_STRING		"3.1.0 (Tandem-STRAIGHT V009ad)"
#define STRAIGHT_TANDEM_V009_ENGINE_VERSION_STRING_SHORT	"V009ad"
#define STRAIGHT_TANDEM_V009_ENGINE_VERSION_ID			3001
#define STRAIGHT_TANDEM_MP002_ENGINE_VERSION_STRING		"3.2.0 (Tandem-STRAIGHT MP002Test)"
#define STRAIGHT_TANDEM_MP002_ENGINE_VERSION_STRING_SHORT	"MP002Test"
#define STRAIGHT_TANDEM_MP002_ENGINE_VERSION_ID			3002
    
#define STRAIGHT_TANDEM_MIN_ENGINE_VERSION_ID		STRAIGHT_TANDEM_V008_ENGINE_VERSION_ID
    
#define STRAIGHT_LATEST_ENGINE_VERSION_ID STRAIGHT_TANDEM_ENGINE_VERSION_ID

    
#if (TARGET_RT_MAC_MACHO || defined(__APPLE__)) && !defined(MACOSX)
#define MACOSX
#endif

#ifdef MACOSX
#ifndef TARGET_API_MAC_CARBON
#define TARGET_API_MAC_CARBON 1
#endif
#ifndef MACOS
#define MACOS
#endif
#ifndef powerc
#define powerc 1
#endif
#endif
    
#ifndef MACOS
#if (defined(__MWERKS__) && defined(macintosh)) || defined(applec) || defined(__MRC__) ||\
    defined(THINK_C) || defined(__SC__) || defined(TARGET_OS_MAC)
#define MACOS
#if !defined(powerc) && defined(__MRC__)
#define powerc 1
#endif
#endif
#endif
	
#if defined(MACOS) && !defined(MACOSX)
#define MACOS9
#ifndef TARGET_API_MAC_CARBON
#define TARGET_API_MAC_CARBON 0
#endif
#endif

typedef enum {
    STRAIGHT_STATE_UNKNOWN = -1,
    STRAIGHT_STATE_INITIAL = 0,
    STRAIGHT_STATE_F0_COMPUTING = 10,
    STRAIGHT_STATE_F0_COMPUTED = 15,
    STRAIGHT_STATE_AP_COMPUTING = 20,
    STRAIGHT_STATE_AP_COMPUTED = 25,
    STRAIGHT_STATE_SPECGRAM_COMPUTING = 30,
    STRAIGHT_STATE_SPECGRAM_COMPUTED = 35,
    STRAIGHT_STATE_SYNTH_COMPUTING = 40,
    STRAIGHT_STATE_SYNTH_COMPUTED = 45,
} stState;
    
typedef int stBool;

#define ST_TRUE  	1
#define ST_FALSE 	0
#define ST_TRUE_STRING	"1"
#define ST_FALSE_STRING	"0"

typedef struct _StraightConfig StraightConfig;
typedef struct _Straight *Straight;
typedef struct _StraightSource *StraightSource;
typedef struct _StraightSpecgram *StraightSpecgram;
typedef struct _StraightSynth *StraightSynth;
typedef struct _StraightAsync *StraightAsync;

struct _StraightConfig {
    unsigned long versionId;
    unsigned long defaultEngineVersionId;
    
    double samplingFrequency;	/* in Hz */
    double frameShift;		/* in msec */
    double frameLength;		/* in msec */
    
    double f0FrameShift;	/* in msec */
    double f0Floor;		/* in Hz */
    double f0Ceil;		/* in Hz */
    
    long FFTLength;
};
    
typedef unsigned long stCallbackType;

typedef stBool (*stCallbackFunc)(Straight straight, stCallbackType callbackType,
				 void *callbackData, void *userData);
typedef stBool (*stAsyncCallbackFunc)(StraightAsync async, stCallbackType callbackType,
				      void *callbackData, void *userData);
    

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __STRAIGHTDEFS_H */
